/* Copyright (c) 1997 The Regents of the University of California.
* For information on usage and redistribution, and for a DISCLAIMER OF ALL
* WARRANTIES, see the file, "LICENSE.TERMS," in this distribution.  */

#ifdef IRIX
#include <dlfcn.h>
#endif
#ifdef NT
// #include <winbase.h>
#include <windows.h>
// #include <mmsystem.h>
#endif
#include <string.h>
#include "m_pd.h"

#define MAXFILENAME 1000

typedef void (*t_xxx)(void);
int sys_loademup(char *classname)
{
    char filename[MAXFILENAME], symname[MAXFILENAME];
    void *dlobj;
    t_xxx makeout;
    if (strlen(classname) > MAXFILENAME - 15) return (0);
    filename[0] = 0;
    if (*classname != '/')
    {
    	strcpy(filename, "./");
    	strcpy(symname, classname);
    }
    else
    {
    	/* need to get the actual name of the dso */
        char tempFilename[MAXFILENAME];
        char *loadlib, *holderLib;
        strcpy(tempFilename, classname);
        holderLib = loadlib = strtok(tempFilename, "/");          
        while(loadlib)
        {
    	    holderLib = loadlib;
            loadlib = strtok(NULL, "/");
        }
        strcpy(symname, holderLib);
    }
    strcat(filename, classname);
    strcat(symname, "_setup");
#ifdef IRIX
    {
    	void *dlobj;
    	strcat(filename, ".pd_irix5");
    	if (!sys_isreadablefile(filename)) return (0);
    	dlobj = dlopen(filename,  RTLD_NOW);
	if (!dlobj)
	{
	    post("%s: %s", filename, dlerror());
	    return (0);
	}
	makeout = (t_xxx)dlsym(dlobj,  symname);
    }
#endif
#ifdef NT
    {
    	HINSTANCE ntdll;
    	strcat(filename, ".dll");
    	ntdll = LoadLibrary(filename);
    	if (!ntdll)
    	{
	    post("%s: couldn't load", filename);
	    return (0);
	}
    	makeout = (t_xxx)GetProcAddress(ntdll, symname);  
    }
#endif
    if (!makeout)
    {
    	post("load_object: Symbol \"%s\" not found", symname);
    	return 0;
    }
    (*makeout)();
    return (1);
}
