/* Copyright (c) 1997 The Regents of the University of California.
* For information on usage and redistribution, and for a DISCLAIMER OF ALL
* WARRANTIES, see the file, "LICENSE.TERMS," in this distribution.  */

/* data handling */

#include "m_pd.h"
#include <math.h>

/* -------------------------- get ------------------------------ */

static t_class *get_class;

typedef struct _get
{
    t_object x_obj;
    t_symbol *x_arrayname;
    t_symbol *x_fieldname;
} t_get;

static void *get_new(t_symbol *arrayname, t_symbol *fieldname)
{
    t_get *x = (t_get *)pd_new(get_class);
    x->x_fieldname = fieldname;
    x->x_arrayname = arrayname;
    post("get %s/%s", fieldname->s_name, arrayname->s_name);
    outlet_new(&x->x_obj, &s_float);
    symbolinlet_new(&x->x_obj, &x->x_arrayname);
    symbolinlet_new(&x->x_obj, &x->x_fieldname);
    return (x);
}

static void get_int(t_get *x, t_intarg n)
{
    t_array *a = (t_array *)pd_findbyclass(x->x_arrayname, array_class);
    if (!a) error("get %s: no such array", x->x_arrayname->s_name);
    else outlet_float(x->x_obj.ob_outlet, array_get(a, x->x_fieldname, n));
}

static void get_setup(void)
{
    get_class = class_new(gensym("get"), get_new, 0,
    	sizeof(t_get), 0, A_DEFSYM, A_DEFSYM, 0);
    class_addint(get_class, get_int);
}

void x_data_setup(void)
{
    get_setup();
}
